--東風谷早苗用ai
--しなうす式/20220710check

require("function_pun_strage.lua")
head_req_list()

function main()
--シード生成、スレッド生成、base_states設定
	set_seedthreadstates()
--キャラ確認
	char_calling()
--ステージが 核融合炉心部 だと超反応モードに
	set_printsabot()

while true do
--スレッド外初期化
	while_top()

--●どちらかが体力無くなったら待機
	if interbattle_condi()==true then
		interbattle_exe()
--▼開幕行動▼
	elseif kaimaku_condi()==true then
		kaimaku_exe()
--▼移動起き上がり
	elseif my_act==97 or my_act==98 then --基本：画面端より遠ざかる。中央では相手から遠ざか…りたいが、設置技警戒のため、相手側に移動起き上がり。
		movedgetup_exe()

--▼簡易受け身▼：攻撃ないし回避いずれの目的であってもリカバリーポイントは限られるが、そういうことはさておき実装したもの
	elseif recovery_condi()==true then
		recovery_exe()

--▼台風になった時、フラグに従って「緋想の剣」を使用
	elseif y==0 and my_act<=10 and card_check(14) and flag_kishitu==1 then
		print("天候フラグＯＮ　⇒　「緋想の剣」使用");
		card_use(14);

--▼台風▼：近接状態からの強引な状況変更を行う行動。スペカなど使用。
	elseif react_rejecttaihu_condi()==true then
		react_rejecttaihu_exe()

--▼起き攻め▼
	elseif setplay_ongetup_condi()==true then
		setplay_ongetup_exe()
--▼ＨＪＣ▼
	--地上HJC
	elseif hjc_ground_condi()==true then
		hjc_ground_exe()
	--空中HJC
	elseif hjc_air_condi()==true then
		hjc_air_exe()

--▼反応行動
--反応：下段
	elseif 	react_lowattack_condi()==true then
		react_lowattack_exe()
--反応：地対空
	elseif react_g2a_condi()==true then
		react_g2a_exe()
--反応：低空飛翔
	elseif react_lowj6d_condi()==true then
		react_lowj6d_exe()
--上空追いかけ
	elseif ueoikake_condi()==true then
		ueoikake_exe()
--霊撃 or 霊撃札
	elseif reigeki_condi()==true then 
		print("拒否行動：霊撃　⇒　可能ならば使用");
		card_use(0)
		
--▼グレイズ：相手行動に対する反射or一定距離内のオブジェクト感知▼
--モーション反応グレイズ
	elseif
	graze_condition_xrange()==true and
	state_nottrueguard()==true and 
	my_airEX>=1 and 
	my_rei>=0 
	then--近距離時のグレイズ。のさばらせておくと、誤結界の原因となる。ガードの硬直間際ならok
		print("check 1 -> graze act X Range");
		graze_action_xrange()
			
--▼ ガード行動：簡易ガードルーチン▼
--▼ ガード反撃、龍魚の羽衣 13
	elseif hagoromo_1st_condi()==true or hagoromo_condi()==true then
		hagoromo_exe()

--回避結界
	elseif kekkai_condi()==true then
		kekkai_exe()

--▼ 宵越しの銭 12
	elseif yoikoshi_1st_condi()==true or yoikoshi_condi()==true then
		yoikoshi_exe()

--▼汎用中下段ガード
--基本は行動に対して後退入れ込み。下段のみ抽出して反応。通常射撃も同じく下段で受ける(けどメンドウだから今回は省き)。フラグを抜けてくるものは別個に対応
	elseif lowattack_aflags_condi()==true then
		guard_backexpectlowattack_exe()
	elseif overheadattack_aflags_condi()==true then
		guard_backoverheadattack_exe()
--下段判定をフィルタ
	elseif lowattack_flaged_condi()==true then
		guard_backexpectlowattack_exe()
--フラグを抜けてくるものをフィルタ
	elseif lowattack_unflaged_condi()==true then
		guard_backexpectlowattack_exe()
--屈状態では低空昇り攻撃には立てない
	elseif notstand_overhead_upjump_condi()==true then
		guard_backexpectlowattack_exe()
--以下、何もフィルタされなかった場合、立ちガード
	elseif guard_pun_condi()==true then
		guard_backoverheadattack_exe()

--[[▼オブジェが至近距離の場合、着地直前にｈｊを仕込む、タッチ＆ゴーグレイズ
	elseif touchandgo_00_condi() then
		touchandgo_00_exe()
--オブジェが至近距離の場合、ガードの前に、離陸
	elseif touchandgo_01_condi() then
		touchandgo_01_exe()
	elseif touchandgo_02_condi() then
		touchandgo_02_exe()
--]]
--オブジェが至近距離の場合、空中から地上へ飛翔　※咲夜：２D：120.0以上、３D：84.9以上必要
	elseif graze_pun_condi()==true then
		graze_pun_exe()
		
--遠距離時のグレイズ
	elseif graze_farground_condi() then
		graze_farground_exe()
	elseif graze_farair_condi() then
		graze_farair_exe()
		
--特定状況におけるガード
	elseif guard_objgimmick_condi()==true then
		guard_backexpectlowattack_exe()
--オブジェが至近距離の場合、ガード:射撃と打撃を重ねられると、しゃがみガードしてしまう。優先順位の変更が必要
	elseif guard_objclosedis_condi()==true then
		guard_backexpectlowattack_exe()
	
--▼起き上がり直後の行動
	elseif move_soonaftergetup_condi()==true then
		move_soonaftergetup_exe()

--▼コンボ▼
--AAAAコンボ
	elseif my_act==300 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
		print("AA");
		key_event(ACT_A);
		elseif ey==0 and my_act==320 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
			print("AAA");
			key_event(ACT_A);
			elseif ey==0 and my_act==321 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and ((enemy_act>=50 and enemy_act<=89 or enemy_act==143) or (enemy_act>=145 and enemy_act<=166 and math.random(2)<=1)) then
				print("AAAA");
				key_event(ACT_A);
--遠A>6A
	elseif my_act==301 and enemy_act>=50 and enemy_act<=166 and my_hitstop<=3 and my_hitstop>=1 and is_dir_front==true and math.random(2)==1 then
		key_resetEX();
		print("遠Ａ＞６Ａ");
		key_event2(ACT_A,front);
		
--▼固め▼

--▼攻撃▼

--▼spell card▼

--▼cost2

--	祈願「商売繁盛守り」
	--Ground
	elseif card_check(200)==true and
		my_spell_more(1000) and
		(ex-x)*my_dir>-200 and
		y==0 and
		ey<120 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("祈願「商売繁盛守り」");
			for i=1,10 do
				card_use(200);
				yield()
			end

--秘術「グレイソーマタージ」
	--Ground
	--Air
	elseif card_check(201)==true and
		my_spell_more(1000) and
		dis2<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("秘術「グレイソーマタージ」");
			for i=1,10 do
				card_use(201);
				yield()
			end

--神籤「乱れおみくじ連続引き」
	--Ground
	elseif card_check(203)==true and
		my_spell_more(1000) and
		dis<640 and
		y==0 and
		ey<360 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("神籤「乱れおみくじ連続引き」");
			for i=1,10 do
				card_use(203);
				yield()
			end

--▼cost3

--開海「海が割れる日」
	--Ground
	elseif card_check(204)==true and
		my_spell_more(1500) and
		dis<240 and
		y==0 and
		ey<120 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("開海「海が割れる日」");
			for i=1,10 do
				card_use(204);
				yield()
			end

--奇跡「白昼の客星」
	--Ground
	elseif card_check(206)==true and
		my_spell_more(1500) and
		dis>360 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("奇跡「白昼の客星」");
			for i=1,10 do
				card_use(206);
				yield()
			end

--▼cost4

--秘術「忘却の祭儀」
	--Ground
	elseif card_check(202)==true and
		my_spell_more(2000) and
		dis2<180 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("秘術「忘却の祭儀」");
			for i=1,10 do
				card_use(202);
				yield()
			end

--奇跡「客星の明るすぎる夜」
	--Ground
	elseif card_check(207)==true and
		my_spell_more(2000) and
		--dis<200 and
		y==0 and
		ey>180 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("奇跡「客星の明るすぎる夜」");
			for i=1,10 do
				card_use(207);
				yield()
			end

--▼cost5

--開海「モーゼの奇跡」
	--Ground
	elseif card_check(205)==true and
		my_spell_more(2500) and
		--dis<200 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("開海「モーゼの奇跡」");
			for i=1,10 do
				card_use(205);
				yield()
			end

--	秘法「九字刺し」
	--Ground
	elseif card_check(210)==true and
		my_spell_more(2500) and
		dis>360 and
		y==0 and
		--ey<100 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
			print("秘法「九字刺し」");
			for i=1,10 do
				card_use(210);
				yield()
			end

--▼skill▼

--▼スキル236

--風起こし100
	elseif get_skill_lv(0,0)>=0 and 
		my_rei>=400 and
		dis>320 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("風起こし");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,0)>=0 and 
		my_rei>=400 and
		dis>320 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("風起こし");
			lvr236(ACT_C);
			
	elseif card_check(100)==true and 
		my_rei>=400 and
		dis>320 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("風起こし");
			for i=1,10 do
				card_use(100);
				yield()
			end
			
--波起こし104
	elseif get_skill_lv(0,4)>=0 and 
		my_rei>=400 and
		dis<180 and
		y==0 and
		ey<120 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("波起こし");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,4)>=0 and 
		my_rei>=400 and
		dis>180 and dis<360 and
		y==0 and
		ey<90 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("波起こし");
			lvr236(ACT_C);
			
	elseif card_check(104)==true and 
		my_rei>=400 and
		dis<180 and
		y==0 and
		ey<120 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		--is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("波起こし");
			for i=1,10 do
				card_use(104);
				yield()
			end
			
--星落とし108
	elseif get_skill_lv(0,8)>=0 and 
		my_rei>=400 and
		dis<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("星落とし");
			lvr236(ACT_B);
			
	elseif get_skill_lv(0,8)>=0 and 
		my_rei>=400 and
		dis>180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("星落とし");
			lvr236(ACT_C);
			
	elseif card_check(108)==true and 
		my_rei>=400 and
		dis<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("星落とし");
			for i=1,10 do
				card_use(108);
				yield()
			end
			
--▼スキル623

--乾神招来 突102
	elseif get_skill_lv(0,2)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis>0 and
		dis_y<120 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 突");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,2)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis>420 and
		dis_y<90 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 突");
			lvr623(ACT_C);
			
	elseif card_check(102)==true and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis>0 and
		dis_y<120 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		--enemy_obj_range_in(150,60)==false) and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 突");
			for i=1,10 do
				card_use(102);
				yield()
			end
			
--乾神招来 風106
	elseif get_skill_lv(0,6)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		--dis>0 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 風");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,6)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		--dis>0 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 風");
			lvr623(ACT_C);
			
	elseif card_check(106)==true and get_special_data(0,24)<1 and 
		my_rei>=400 and
		--dis>320 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 風");
			for i=1,10 do
				card_use(106);
				yield()
			end
			
--乾神招来 御柱110
	elseif get_skill_lv(0,10)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 御柱");
			lvr623(ACT_B);
			
	elseif get_skill_lv(0,10)>=0 and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 御柱");
			lvr623(ACT_C);
			
	elseif card_check(110)==true and get_special_data(0,24)<1 and 
		my_rei>=400 and
		dis<180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("乾神招来 御柱");
			for i=1,10 do
				card_use(110);
				yield()
			end

--▼スキル22

--おみくじ爆弾101
	elseif get_skill_lv(0,1)>=0 and 
		my_rei>=400 and
		dis2>240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("おみくじ爆弾");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,1)>=0 and 
		my_rei>=400 and
		dis2>240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("おみくじ爆弾");
			lvr22(ACT_C);
			
	elseif card_check(101)==true and 
		my_rei>=400 and
		dis>240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(640)==1 then
			print("おみくじ爆弾");
			for i=1,10 do
				card_use(101);
				yield()
			end
			
--スカイサーペント105
	elseif get_skill_lv(0,5)>=0 and 
		my_rei>=400 and
		dis>180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スカイサーペント");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,5)>=0 and 
		my_rei>=400 and
		dis>180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スカイサーペント");
			lvr22(ACT_C);
			
	elseif card_check(105)==true and 
		my_rei>=400 and
		dis>180 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("スカイサーペント");
			for i=1,10 do
				card_use(100);
				yield()
			end
			
--コバルトスプレッド109
	elseif get_skill_lv(0,9)>=0 and 
		my_rei>=400 and
		dis>120 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("コバルトスプレッド");
			lvr22(ACT_B);
			
	elseif get_skill_lv(0,9)>=0 and 
		my_rei>=400 and
		dis>120 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("コバルトスプレッド");
			lvr22(ACT_C);
			
	elseif card_check(109)==true and 
		my_rei>=400 and
		dis>120 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("コバルトスプレッド");
			for i=1,10 do
				card_use(109);
				yield()
			end

--▼スキル214

--坤神招来 盾103
	elseif get_skill_lv(0,3)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 盾");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,3)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 盾");
			lvr214(ACT_C);
			
	elseif card_check(103)==true and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		--y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 盾");
			for i=1,10 do
				card_use(103);
				yield()
			end
			
--坤神招来 鉄輪107
	elseif get_skill_lv(0,7)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis<240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 鉄輪");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,7)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis<240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 鉄輪");
			lvr214(ACT_C);
			
	elseif card_check(107)==true and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis<240 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 鉄輪");
			for i=1,10 do
				card_use(107);
				yield()
			end
			
--坤神招来 罠111
	elseif get_skill_lv(0,11)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 罠");
			lvr214(ACT_B);
			
	elseif get_skill_lv(0,11)>=0 and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 罠");
			lvr214(ACT_C);
			
	elseif card_check(111)==true and get_special_data(0,25)<1 and 
		my_rei>=400 and
		dis>360 and
		y==0 and
		not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
		get_fflags(0,32)==true and
		get_fflags(0,8)==false and get_fflags(1,8)==false and 
		enemy_obj_range_in(150,60)==false and 
		is_dir_front==true and 
		subs_count>=530 and nega_count ~= 1 and math.random(160)==1 then
			print("坤神招来 罠");
			for i=1,10 do
				card_use(111);
				yield()
			end

--[[
--▼skill card▼

	--▼スキル236

		--博麗アミュレット,100,500,g,a
			--g,a
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_B);
				
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>450 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(100)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						card_use(100);
		
		--妖怪バスター,104,505,g,a
			--g,a
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_C);
					
				elseif card_check(104)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						card_use(104);
		
		--拡散アミュレット,108,510,g

				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(108)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						card_use(108);
		
	--▼スキル623

		--昇天脚,103,560,g

				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<300 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					--enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(103)==true and my_rei>=400 and
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						card_use(103);
		
		--抄地昇天脚,107,565,g
			--g
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<300 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(107)==true and my_rei>=400 and
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						card_use(107);
		
		--雨乞祈り,111,570,g,a
			--g,a
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_C);
					
				elseif card_check(111)==true and my_rei>=400 and
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						card_use(111);

	--▼スキル421
		--亜空穴,102,540,g,a
			--g,a
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(102)==true and my_rei>=400 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						card_use(102);
		
		--封魔亜空穴,106,545,g,a
			--g,a
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis>300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(106)==true and my_rei>=400 and
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						card_use(106);
		
		--刹那亜空穴,110,550,g
			--g
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==true and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(110)==true and my_rei>=400 and
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						card_use(110);

	--▼スキル214
		--警醒陣,101,520,g,a
			--g,a
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>300 and dis<600 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_C);
					
				elseif card_check(101)==true and my_rei>=400 and
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						card_use(101);	
		
		--繋縛陣,105,525,g,a
			--g,a
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_yspeed)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_C);
					
				elseif card_check(105)==true and my_rei>=400 and
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						card_use(105);
		
		--常置陣,109,530,g
			--g
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>500 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_C);
					
				elseif card_check(109)==true and my_rei>=400 and
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						card_use(109);
--]]
			
--▼攻撃▼
--▼空中打撃▼

--J5A:-40-170x35-140,12-14,0
	elseif	y>0 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(2)==1 and
	(y+my_yspeed*14+(14*(13*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*14		<=	170+20 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*14		>=	-40-20 	and
				(ey+enemy_yspeed*14+(14*(13*e_gs))/2)	-	(y+my_yspeed*14+(14*(13*m_gs))/2)	<=	140-40		and --自ヒットボックスの上端を、相手ヒットボックスの下端に当てた高さ
				(ey+enemy_yspeed*14+(14*(13*e_gs))/2)	-	(y+my_yspeed*14+(14*(13*m_gs))/2)	>=	35-160 	then  --自ヒットボックスの下端を、相手ヒットボックスの上端に当てた高さ
					print("J5A");
					key_event(ACT_A);
					
--J6A:35-180x40-140-200,13-15,13f~-4x7g0.5
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed*13+(13*(12*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX*13+enemy_xspeedEX*15)*1		<=	180+20 	and
				(ex-x)*my_dir-(my_xspeedEX*13+enemy_xspeedEX*15)*1		>=	35-20 	and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*13+(13*(12*m_gs))/2)	<=	170-40		and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*13+(13*(12*m_gs))/2)	>=	40-160 	then
					print("J6A");
					key_event2(ACT_A,front);
					
--J2A:-15-35x0-60,11-50,s/2x
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(8)==1 and
	(y+my_yspeed*11+(11*(10*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX/2*11+enemy_xspeedEX*11)*1		<=	35+20 	and
				(ex-x)*my_dir-(my_xspeedEX/2*11+enemy_xspeedEX*11)*1		>=	-15-20 	and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)	<=	60-40		and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)	>=	0-160 	then
					print("J2A");
					key_event2(ACT_A,ACT_DOWN);
					
--J8A:-60-120x95-290,13-14,11f~2x15g0.85
	elseif	y>0 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and
	(y+my_yspeed*11+(11*(10*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX*11+2*2+enemy_xspeedEX*13)*1		<=	120+20 	and
				(ex-x)*my_dir-(my_xspeedEX*11+2*2+enemy_xspeedEX*13)*1		>=	-60-20 	and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)+15*2	<=	290-40		and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	(y+my_yspeed*11+(11*(10*m_gs))/2)+15*2	>=	95-160 	then
					print("J8A");
					key_event2(ACT_A,ACT_UP);

--▼対空行動

--対空9HJ>J5A:-40-170x35-140,12-14,0
--j/hj攻撃不能時間:6f
	elseif y==0 and 
	(ey>0 or --空中か
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162)) --諏訪子以外の立ち状態か
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166)) --諏訪子のしゃがみ状態
			)
		)
	) and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(12*12+enemy_xspeedEX*18)		<=	170+20 	and --自機のhj時におけるx軸速度*発生
				(ex-x)*my_dir	-	(12*12+enemy_xspeedEX*18)		>=	-40-20 	and
				(ey+enemy_yspeed*18+(18*(17*e_gs))/2)	-	(y+17*12+(12*(11*-0.75))/2)	<=	140-40		and --自機のhj時におけるy軸速度*発生(hj時の落下加速度を17としている)
				(ey+enemy_yspeed*18+(18*(17*e_gs))/2)	-	(y+17*12+(12*(11*-0.75))/2)	>=	35-160 	then --hj時の落下加速度を-0.75としている
					print("AA:9HJ>J5A");
					key_event2(ACT_D,u_front)
					wait(3)
					key_event(ACT_A);
					wait(3)
			
--対空8HJ>J5A:-40-170x35-140,12-14,0
	elseif y==0 and 
	(ey>0 or --空中か
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162)) --諏訪子以外の立ち状態か
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166)) --諏訪子のしゃがみ状態
			)
		)
	) and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(enemy_xspeedEX*18)		<=	170+20 	and --自機のhj時におけるx軸速度*発生
				(ex-x)*my_dir	-	(enemy_xspeedEX*18)		>=	-40-20 	and
				(ey+enemy_yspeed*18+(18*(17*e_gs))/2)	-	(y+20*12+(12*(11*-0.75))/2)	<=	140-40		and --自機のhj時におけるy軸速度*発生(hj時のy軸速度を20としている)
				(ey+enemy_yspeed*18+(18*(17*e_gs))/2)	-	(y+20*12+(12*(11*-0.75))/2)	>=	35-160 	then --hj時の落下加速度を-0.75としている
					print("AA:9HJ>J5A");
					key_event2(ACT_D,u_front)
					wait(3)
					key_event(ACT_A);
					wait(3)
			
--対空6A:25-175x30-270,16-18,+40
	elseif	y==0 and 
	--dis<120 and
	ey>0 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir	-	(enemy_xspeedEX*16)				<=	175+20 	and
				(ex-x)*my_dir	-	(enemy_xspeedEX*16)				>=	25-20 	and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)		<=	270-40 		and
				(ey+enemy_yspeed*16+(16*(15*e_gs))/2)		>=	30-160 	then
					print("対空6A");
					key_event2(ACT_A,front);
		
--▼刻み▼
		
--[[刻み2Ａ
	elseif (dis<=120 or (dis<=150 and my_xspeed>0)) and 
	my_act==303 and ey==0 and 
	my_hitstop<=3 and my_hitstop>=2 and 
	enemy_obj_range_in(150,60)==false and 
	(
		(enemy_act>=50 and enemy_act<=89 and math.random(1)<=1) or
		(enemy_act>=143 and enemy_act<=166 and math.random(3)<=2)
	) and 
	subs_count>=530 and nega_count ~= 1 then
		print("刻み2Ａ");
		key_event2(ACT_A,ACT_DOWN);
		wait(5); --]]
		
--▼通常技/Arts▼

--S5A:10-150x60-120,7-8,
	elseif dis<=120 and 
	dis<=150+(enemy_xspeedEX)*7 and
	y==0 and 
	ey<100 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("S5A");
		key_event(ACT_A);
--L5A:-40-160x5-80,11-12,
	elseif dis>120 and 
	dis<=160+(enemy_xspeedEX)*11 and
	y==0 and 
	ey<100 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("S5A");
		key_event(ACT_A);
--4A:10-150x60-120,7-8,
	elseif --dis<=120 and 
	dis<=150+(enemy_xspeedEX)*8 and
	y==0 and 
	ey<100 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(8)==1 then
		print("4A");
		key_event2(ACT_A,back);
--2A:170x60,9-10,+40
	elseif dis<=170+40+(enemy_xspeedEX)*10 and
	y==0 and 
	ey<100 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("2A");
		key_event2(ACT_A,ACT_DOWN);
--3A:190x60,17-28,+120
	elseif dis<=190+120+(enemy_xspeedEX)*28 and
	dis>=150+120+(enemy_xspeedEX)*28 and
	y==0 and 
	ey<100 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(8)==1 then
		print("3A");
		key_event2(ACT_A,d_front);
--3AHr:190x60,32-47,+220
	elseif dis<=190+220+(enemy_xspeedEX)*47 and
	dis>=150+220+(enemy_xspeedEX)*47 and
	y==0 and 
	ey<100 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("3AHr");
		key_on(ACT_A)
		key_on(d_front);
		wait(15)

--6A:25-175x30-270,16-18,+40
	elseif dis<=175+40+(enemy_xspeedEX)*18 and
	y==0 and 
	ey<270 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("6A");
		key_event2(ACT_A,front);
--6AHr:25-175x30-270,31-33,+90
	elseif dis<=175+90+(enemy_xspeedEX)*33 and
	y==0 and 
	ey<270 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("6AHr");
		key_on(ACT_A)
		key_on(frontEX());
		wait(15)

--DA:180x30-70-150,14-15,+160
	elseif dis<=180+120+(enemy_xspeedEX)*15 and
	dis>=140+120+(enemy_xspeedEX)*15 and
	y==0 and 
	ey<150 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(8)==1 then
		print("DA");
		key_on(frontEX());
		key_event2(ACT_D,ACT_A);
--DB:220x60-180,15-17,+280
	elseif dis<=220+240+(enemy_xspeedEX)*17 and
	dis>=180+240+(enemy_xspeedEX)*17 and
	y==0 and 
	ey<180 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false) and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(8)==1 then
		print("DB");
		key_on(frontEX());
		key_event2(ACT_D,ACT_B);
--DC-1:170x260,16-17,
	elseif dis<=140+100+(enemy_xspeedEX)*17 and
	--dis>=130+115+(enemy_xspeedEX)*17 and
	y==0 and 
	ey<260 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("DC1");
		key_on(frontEX());
		key_event2(ACT_D,ACT_C);
--DC-2:140x300,31-34,+270
	elseif dis<=140+230+(enemy_xspeedEX)*34 and
	--dis>=100+230+(enemy_xspeedEX)*34 and
	y==0 and 
	ey<300 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("DC2");
		key_on(frontEX());
		key_event2(ACT_D,ACT_C);

--5B/J5B:
	elseif my_rei>=400 and
	dis>360 and
	--y==0 and
	ey-y>-1*(ex-x)*my_dir+90 and 
	ey-y<1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("5B/J5B");
		key_event(ACT_B);
--5B/J5B:Hr
	elseif my_rei>=400 and
	dis>360 and
	--y==0 and
	ey-y>-1*(ex-x)*my_dir+90 and 
	ey-y<1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("5B/J5B:Hr");
		key_on(ACT_B)
		--key_on(frontEX());
		wait(18)
		
--6B:
	elseif my_rei>=400 and
	dis2<480 and
	y==0 and
	--ey-y>0.5*(ex-x)*my_dir+90 and 
	ey-y>-1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("6B");
		key_event2(ACT_B,front);
--6B:Hr
	elseif my_rei>=400 and
	dis2<480 and
	y==0 and
	--ey-y>0.5*(ex-x)*my_dir+90 and 
	ey-y>-1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("6B:Hr");
		key_on(ACT_B)
		key_on(frontEX());
		wait(15)
		
--J2B:
	elseif my_rei>=400 and
	dis2<480 and
	y>0 and
	--ey-y>0.5*(ex-x)*my_dir+90 and 
	ey-y>-1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("J2B");
		key_event2(ACT_B,ACT_DOWN);
--J2B:Hr
	elseif my_rei>=400 and
	dis2<480 and
	y>0 and
	--ey-y>0.5*(ex-x)*my_dir+90 and 
	ey-y>-1*(ex-x)*my_dir+90 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("J2B:Hr");
		key_on(ACT_B)
		key_on(ACT_DOWN);
		wait(19)
		
--2B:
	elseif my_rei>=400 and
	--dis2<480 and
	y==0 and
	ey-y>2*(ex-x)*my_dir-180 and 
	ey-y>-2*(ex-x)*my_dir-180 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("2B");
		key_event2(ACT_B,ACT_DOWN);
--2B:Hr
	elseif my_rei>=400 and
	--dis2<480 and
	y==0 and
	ey-y>2*(ex-x)*my_dir-180 and 
	ey-y>-2*(ex-x)*my_dir-180 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("2B:Hr");
		key_on(ACT_B)
		key_on(ACT_DOWN);
		wait(15)
		
--5C/J5C:
	elseif my_rei>=400 and
	dis>240 and
	--y==0 and
	ey-y<120 and
	ey-y>-120 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("5C/J5C");
		key_event(ACT_C);
--5C/J5C:Hr
	elseif my_rei>=400 and
	dis>240 and
	--y==0 and
	ey-y<120 and
	ey-y>-120 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("5C/J5C:Hr");
		key_on(ACT_C)
		--key_on(frontEX());
		wait(19)
		
--6C/J6C:
	elseif my_rei>=400 and get_special_data(0,24)<1 and
	dis<360-60 and
	ey-y<140-60 and
	ey-y>-120+60 and
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("6C/J6C");
		key_event2(ACT_C,front);
		
--4C/J4C:
	elseif my_rei>=400 and get_special_data(0,25)<1 and
	dis<480 and
	ey<450 and
	ey<1*(ex-x)*my_dir+240 and
	ey>1*(ex-x)*my_dir-150 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(32)==1 then
		print("4C/J4C");
		key_event2(ACT_C,back);
		
--2C:
	elseif my_rei>=400 and
	--dis2<480 and
	y==0 and
	ey-y<1*(ex-x)*my_dir+400 and 
	ey-y<-1*(ex-x)*my_dir+400 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("2C");
		key_event2(ACT_C,ACT_DOWN);
		
--J2C:
	elseif my_rei>=400 and
	--dis2<480 and
	--y==0 and
	ey-y<1*(ex-x)*my_dir+360 and 
	ey-y<-1*(ex-x)*my_dir+360 and 
	not(my_act>=50 and my_act<180) and my_act~=200 and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(16)==1 then
		print("J2C");
		key_event2(ACT_C,ACT_DOWN);

--]]
--中距離以上からの８ｈｊ
	elseif move_8hjattakeovermidrange_condi()==true then
		print("中距離以上で８ＨＪ");
		key_event2(ACT_D,ACT_UP);
--中距離からのダッシュ
	elseif move_6dattakeovermidrange_condi()==true then
		print("ダッシュ接近");
		key_event2(ACT_D,front);
--低空飛翔で接近
	elseif move_approachbylowflaying_condi()==true then
		move_approachbylowflaying_exe()
--８８３飛翔
	elseif move_approachby883d_condi()==true then
		move_approachby883d_exe()
--▼ 終端運動
--▼ 相手上空へ飛び上がった際の処理
	elseif move_attakeoverhead_condi()==true then
		move_attakeoverhead_exe()
--▼ 終端機動
	--▼ 対台風時
	elseif move_terminationtaihu_condi()==true then
		move_terminationtaihu_exe()
	--▼ 終端機動1
	--台風じゃない時だが…
	elseif move_termination1_condi()==true then
		move_termination1_exe()
	--▼ 終端機動2
	--ただ動く事で自律性を錯覚させる事が目的の機動。静止やラインの設定に大きな根拠はない。
	--霊力が一定の評価を下回った場合、実行しない。
	elseif move_termination2_condi()==true then
		move_termination2_exe()
	end
	
	yield()
end
end